/* fc_init.c */

#include <tk.h>
#include <stdlib.h>  /* getenv() */
#include "fc.c"

extern int source_file(Tcl_Interp *interp, char* name);

#define TE(x) if (Tcl_Eval(interp, x) != TCL_OK) fprintf(stderr," failed %s
",interp->result);
 
int Fc_Init(Tcl_Interp *interp)
{
  static struct {
    char *name;
    char *var;
    char *def;
  } libraries[] = {
    {"FC_LIBRARY",    "fc_library",   "."},
    {0,0}
  };
 
  extern int Tcl_SetSockBuffer_cmd(ClientData clientData, Tcl_Interp *interp, 
			  int argc, char **argv);

  extern char *prog_name;

  int i;
  
  Tcl_SetVar(interp, "prog_name",prog_name, TCL_GLOBAL_ONLY);
  
  /*
   * Call Tcl_CreateCommand for application-specific commands, if
   * they weren't already created by the init procedures called above.
   */
  Tcl_CreateCommand(interp, "Tcl_SetSockBuffer", Tcl_SetSockBuffer_cmd, 0, 0);

  /* set up bitmaps */
 
  /* set up library directories */
  for (i = 0; libraries[i].name; i++) {
    char *lib_dir = getenv(libraries[i].name);
    if (lib_dir == NULL) lib_dir = libraries[i].def;
    Tcl_SetVar(interp, libraries[i].var, lib_dir, TCL_GLOBAL_ONLY);
  }
  
  if (source_file(interp, "$fc_library/fc.tcl") < 0) {
    TE(fc_tcl)
  }
   return TCL_OK;    
}
