/* 
 * fc_main.c (tkAppInit.c) --
 *
 *	Provides a default version of the Tcl_AppInit procedure for
 *	use in wish and similar Tk-based applications.
 *
 *
 */

#include "tk.h"
#include <stdlib.h>


#ifdef	__cplusplus
extern "C" {
#endif

extern int		Tk_Init _ANSI_ARGS_((Tcl_Interp *interp));
extern void		Tk_Main _ANSI_ARGS_((int argc, char **argv,
			    Tcl_AppInitProc *appInitProc));

/*
 * The following variable is a special hack that is needed in order for
 * Sun shared libraries to be used for Tcl.
 */

extern int matherr _ANSI_ARGS_((void));

#ifdef	__cplusplus
}
#endif

#ifdef TK_TEST
extern int		Tktest_Init _ANSI_ARGS_((Tcl_Interp *interp));
#endif /* TK_TEST */

#if (TCL_MAJOR_VERSION == 7) && (TCL_MINOR_VERSION < 4)
/*
 * The following variable is a special hack that allows applications
 * to be linked using the procedure "main" from the Tcl7.3 library.  The
 * variable generates a reference to "main", which causes main to
 * be brought in from the library (and all of Tcl with it).
 */

extern int main _ANSI_ARGS_((int argc, char **argv));
static int (*dummyMainPtr) _ANSI_ARGS_((int argc, char **argv)) = main;

#else

/*
 *----------------------------------------------------------------------
 *
 * main --
 *
 *	This is the main program for the application.
 *
 * Results:
 *	None: Tk_Main never returns here, so this procedure never
 *	returns either.
 *
 * Side effects:
 *	Whatever the application does.
 *
 *----------------------------------------------------------------------
 */

char *prog_name;

int

main(argc, argv)
    int argc;			/* Number of command-line arguments. */
    char **argv;                /* Values of command-line arguments. */


{ 
  extern int Udp_Init(Tcl_Interp *interp);
  extern int Fc_Init(Tcl_Interp *interp);
    
    /* save prgram name */
    prog_name = argv[0];

   Et_Init(&argc,argv);

    if (Udp_Init(Et_Interp) == TCL_ERROR) {
      return TCL_ERROR;
    }

   if (Fc_Init(Et_Interp) == TCL_ERROR) {
      return TCL_ERROR;
    }


    Tk_MainLoop();
    return 0;			/* Needed only to prevent compiler warning. */
}
#endif




