/*
* Generate valid Tk window name.
* Return argument with white space removed and some punctuation
* replaced by colons. Initial capitals are converted to lowercase.
*/
#include <tcl.h>
#include <ctype.h>
#include <string.h>
#include "ansi.h"


int noperiod_cmd(ClientData client, Tcl_Interp *interp, int argc, 
  char *argv[])
{
  char *s, *d;

  if (argc != 2) {
    sprintf(interp->result, "%s: illegal # of args (%d)", argv[0], argc);
    return TCL_ERROR;
  }

  d = interp->result;
  for (s = argv[1]; *s; s++) {
    if (strchr(";.,/$", *s)) *d++ = ':';
    else if (!isspace(*s)) *d++ = *s;
  }
  *d = '\0';
  interp->result[0] = tolower(interp->result[0]);
  
  return TCL_OK;
} /* noperiod_cmd */
