#
# Canvas list
#
# $Id: clist.tcl,v 1.2 1998/07/20 16:41:27 stb Exp $
#
proc clist {{w .clist}
  label lw height slist vlist v
} {
  frame $w -relief groove

  if {$lw < 0} {
    set lw [string length $label]
  }
 
  if {[llength $vlist] == 0} {
    set vlist $slist
  }

  canvas $w.c -scrollregion "0c 0c 10c 10c" \
    -height $height -width $height -relief sunken

  frame $w.c.frame -relief raised
  set k 0
  foreach i $slist {
    set value [lindex $vlist $k]
    pack [radiobutton [string tolower $w.c.frame.$value] -text $i \
       -value $value -variable $v -relief flat] -side top -anchor nw
    incr k
  }

  scrollbar $w.s -relief flat -command "$w.c yview"
  $w.c config -yscroll "$w.s set"

  $w.c create window 0 0 -window $w.c.frame -anchor nw -tag frame
  pack \
    [label $w.label -text $label: -width $lw -anchor nw] -side left
  pack $w.c -ipadx 10 -ipady 10 -side left -expand true 
  pack $w.s -side right -fill y

  return $w
}

proc clist_adjust {w} {
  set width [winfo width $w.c.frame]
  set height [winfo height $w.c.frame]
  set c_height [winfo height $w.c]
  if {$c_height > $height} {
    set c_height $height
  }
  $w.c configure -scrollregion "0 0 $width $height" \
    -width $width -height $c_height
}
