#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<string.h>

int open_socket()
{
  int pmm_sd,one=1,ttl=0;
  struct sockaddr_in pmmaddr;
  struct ip_mreq mreq;      /* multicast group */
  struct in_addr interface;
  
  
  bzero(&pmmaddr,sizeof(pmmaddr));
  pmmaddr.sin_port=htons(5010);
  pmmaddr.sin_family=AF_INET;
  pmmaddr.sin_addr.s_addr=inet_addr("225.2.0.1");
  mreq.imr_multiaddr.s_addr = pmmaddr.sin_addr.s_addr;
  mreq.imr_interface.s_addr = htonl(INADDR_ANY);
  interface.s_addr=htonl(INADDR_ANY);
  if((pmm_sd=socket(AF_INET,SOCK_DGRAM,0))<0){
    perror("Create PMM Socket");
    return -1;
  }

  if(setsockopt(pmm_sd, SOL_SOCKET, SO_REUSEADDR, 
		    (char *)&one, sizeof(one))){
    perror("PMM Socket Reuse Address");
    return -1;
  }

  if(setsockopt(pmm_sd, IPPROTO_IP, IP_ADD_MEMBERSHIP, 
		(char *)&mreq, sizeof(mreq)) < 0){
    perror("PMM Socket IP Add Membership");
    return -1;
  }

  if (setsockopt(pmm_sd, IPPROTO_IP, IP_MULTICAST_IF,
		       (char *)&interface, sizeof(interface)) < 0)

  if (setsockopt(pmm_sd, IPPROTO_IP, IP_MULTICAST_TTL,&ttl , 
		       sizeof(unsigned char)) < 0){
    perror("PMM Socket TLL");
    return -1;
  }


  if(bind(pmm_sd,(struct sockaddr*)&pmmaddr,sizeof(pmmaddr))){
      perror("Bind");
      return(-1);
  }
  return pmm_sd;
}


void main()
{
    int sd,bla;
    char pmm[200];
    struct sockaddr_in addr,fromaddr;

    addr.sin_addr.s_addr=inet_addr("225.2.0.1");
    addr.sin_family=AF_INET;
    addr.sin_port=htons(5010);
    sd=open_socket();
    if(sd<0)exit(1);
    strcpy(pmm,"+ Stefan.Boenstein@boof/netghost/224.3.0.12:3456");
    sendto(sd,pmm,strlen(pmm),0,(struct sockaddr*)&addr,sizeof(addr));
    strcpy(pmm,"+ Stefan.Boenstein@boof/netghost/224.3.0.12:3456/*");
    sendto(sd,pmm,strlen(pmm),0,(struct sockaddr*)&addr,sizeof(addr));
    strcpy(pmm,"session Stefan.Bodenstein@boof/netghost/224.3.0.12:3456");
    sendto(sd,pmm,strlen(pmm),0,(struct sockaddr*)&addr,sizeof(addr));    
    recvfrom(sd,pmm,200,0,(struct sockaddr*)&fromaddr,&bla);
    if(strcmp(pmm,"Stefan.Bodenstein@boof/netghost/224.3.0.12:3456/created")==0){
	printf("application did register\n");
    }
    scanf("%d",bla);
    strcpy(pmm,"Stefan.Bodenstein@boof/netghost/224.3.0.12:3456/close");
    sendto(sd,pmm,strlen(pmm),0,(struct sockaddr*)&addr,sizeof(addr));
    recvfrom(sd,pmm,100,0,(struct sockaddr*)&fromaddr,&bla);
    if(strcmp(pmm,"Stefan.Bodenstein@boof/netghost/224.3.0.12:3456/closed")==0){
	printf("application closed\n");
    }
}
