.\"  netghost.man -- Man page for ghostview application with network and
.\"  pointer enhancement
.\"  Copyright (C) 1992  Timothy O. Theisen
.\" 
.\"  This program is free software; you can redistribute it and/or modify
.\"  it under the terms of the GNU General Public License as published by
.\"  the Free Software Foundation; either version 2 of the License, or
.\"  (at your option) any later version.
.\" 
.\"  This program is distributed in the hope that it will be useful,
.\"  but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"  GNU General Public License for more details.
.\" 
.\"  You should have received a copy of the GNU General Public License
.\"  along with this program; if not, write to the Free Software
.\"  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\" 
.\"    Author: Stefan Bodenstein            Systems Programmer
.\"  Internet: bodenst@ft.ee.tu-berlin.de   Telecumication Network Group
.\"    Author: Andreas Koepsel              System Programmer
.\"  Internet: koepsel@ft.ee.tu-berlin.de   Telecumication Network Group
.\"  Technische Universitaet Berlin
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.TH NETGHOST 1
.SH NAME
\fInetghost\fR \- View PostScript documents using ghostscript supporting remote
control and pointer unit
.SH SYNOPSIS
.B netghost
[filename]
.br
or
.br
.B netghost
[\-sender|receiver] [\-address \fIinetaddr\fP]
[\-port \fIportnumber\fP] [\-ttl \fIhopcount\fP]
[\-connection_ID \fIuniqid\fP] [\-interval \fIsec\fP]
[filename]
.SH DESCRIPTION
The \fInetghost\fP program is an enhanced version of the \fIghostview\fP
program which supports remote control and a pointer unit to point within
the text area. Normally one instance of the program should act as a sender 
which transmits event driven and periodically certain status informations.
If a listing instance receives such status packet it will change its state
according to the values in the status packet. This enables the remote 
listeners of a lecture to follow the sequence of slides and to see the 
highlighted spots.
.SH MAIN WINDOW
A pointer support has been added into the main viewport. The Pointer is 
positioned using the right mouse button. Pressing the right mouse button a 
second time will hide the pointer. The Pointer shape, the Pointer color, 
and the mouse button which triggers the pointer can be set by resources. 
.SH POPUP WINDOWS
To control the application there is a new dialog window \fInetpopup\fP. The following parameters can be set using this dialog:
.IP \fBAddress\fP 1i
Here the IP-Address to send to or receive from  is set. In most of the cases 
this should be a multicast address but a unicast address is also possible.
.IP \fBPort\fP 1i
Here the Port to send to or receive from can be choosen.
.IP \fBTTL\fP 1i
The TTL value given here is only valid for sending in a multicast group. It 
determines the range of transmission.
.IP \fBID\fP 1i
Should be an unique integer number. This shall prevent the application to act
on received pakets from other session on the same address and port.
.IP \fBSender or Receiver\fP
This two buttons are mutually exclusive. You can choose the mode of your 
application by clicking one times on the appropriate button. Selecting the
 button a second time cancels the selection. If none of this two buttons is
selected the application acts like the normal \fBghostview\f program.
.SH MENUS
There is one additional menu entry "Network" in the \fBFile\f menu. Selecting this entry will popup the \fBnetdialog\f window.
.SH APPLICATION RESOURCES
The following additional resources can be set.
.IP "\fBaddressPrompt (\fPclass\fB AddressPrompt)\fP" 1i
Sets the prompt used to ask for the IP-address.
.IP "\fBportPrompt (\fPclass\fB PortPrompt)\fP" 1i
Sets the prompt used to ask for the port number.
.IP "\fBttlPrompt (\fPclass\fB TtlPrompt)\fP" 1i
Sets the prompt used to ask for the ttl value.
.IP "\fBconnection_IDPrompt (\fPclass\fB Connection_IDPrompt)\fP" 1i
Sets the prompt used to ask for the unique connection identifier.
.IP "\fBaddress (\fPclass\fB Address)\fP" 1i
Sets the default IP-address
.IP "\fBport (\fPclass\fB Port)\fP" 1i
Sets the default port number
.IP "\fBttl (\fPclass\fB Ttl)\fP" 1i
Sets the default ttl value
.IP "\fBconnection_ID (\fPclass\fB Connection_ID)\fP" 1i
Sets the default connection identifier
.IP "\fBinterval (\fPclass\fB Interval)\fP" 1i
Sets the default repeating interval of status packet in seconds
.SH GHOSTVIEW WIDGET RESOURCES
Some additional resources in the Ghostview widget may be set by the user.
.IP "\fBpointershape (\fPclass\fB Pointershape)\fP" 1i
This enables the user to choose the shape of its pointer unit. It must be a
valid XWindows bitmap file.
.IP "\fBpointercolor (\fPclass\fB Pointercolor)\fP" 1i
Sets the color of the pointer unit.
.SH GHOSTVIEW WIDGET ACTIONS
.IP "\fBtogglepointer(unused)\fP" 1i
One additional action is introduced to show and hide the pointer. The default
is to toggle the pointer state with the right mouse button. The pointer is
centered around the "haircross" mouse pointer.
.SH LIMITATIONS
The status packets are transmitted using unreliable udp packets. Some packets 
may be lost this way. That is the reason why we repeat the packets 
periodically. We do not check if all users see the same postscript 
document. To obtain the file you have to use some kind of file transfer.
.SH AUTHOR
 Stefan Bodenstein bodenst@ft.ee.tu-berlin.de
 Andreas Koepsel koepsel@ft.ee.tu-berlin.de
.SH BUGS
If you find a bug, please send a bug report to the authors.
.SH SEE ALSO
A detailed explanation of the \fBghostview\fP program can be found in the 
\fBghostview\fP manpage.