/*
 * procedures for creating the display and deciding if to display a stream
 * and initializing the needed display and decoding stuff
 */



#include "types.h"
#include "rtp.h"
#include "nevit.h"
#include "x11_grab.h"
#include "x11_grab.h"


extern Tcl_Interp      *interp_;
Tk_Window              mainWindow;
static  XWindowAttributes xwa;
static  int ncolors;
static  XColor *colors=NULL;
/****************************************************************
 * convert the image data to something acceptable for displaying and convert
 * it to gif
 */
int write_snap(int w, int h,char* image, char* theVisual,char* name)
{
  FILE *fp;

  if(image==NULL)
    return;
  if(convertImage((XImage *)image, colors, ncolors, &xwa,(Visual *)theVisual)
     ==0) {
    fprintf(stderr," could not convert Image \n");
    return -1;
  }
  if ((fp = fopen(name, "w"))==NULL)
    return 0;
  fprintf(stderr," w=%i h=%i \n",gWIDE,gHIGH);
  WriteGIF(fp,grabPic,gbits,w,h,grabmapR,grabmapG,grabmapB,256,8,"");
  fclose(fp);
  if(grabPic!=NULL) free(grabPic); grabPic=NULL;
  return 0;
}
/**************************************************************************/
int display_frame(char* image,int len,char * decoder)
{
  /* decode and disply the image */
  if(s->local->decoder==NULL)
    s->local->decoder=create_display(s->local->decoder);

  s->local->decompress(image,(int )len,s->codec.quality,
		       s->local->decoder,(char *)s->local->theImage);
  s->local->draw(0,0,s->local->width,
		 s->local->height,
		 (char *)s->local->theImage,
		 (char *)s->local->theDisp,(char *)s->local->theGC,
		 (char *)s->local->mainW,s->local->cname,
		 (char *)s->local->shminfo);
  
  return 1;
}



/**************************************************************************/
/*
 * create a video slot entry to preview the locally sent data
 * return NULL on failiure
 * return the decoder structure on success
 */
/*
* do the necessary steps for creating a window slot for a connection
* return a memeber session for previewing
* return NULL for do not preview
*/
member_t* receive_display(session_t * s, char* cname, int on)
{
  Tcl_HashEntry *entryPtr;
  Tcl_HashSearch search;
  member_t *m=NULL;
  char *error="-1";
  if(s->scale_factor==2){/* set this member to active display and the 
				     currently active to preview=2 */
    for (entryPtr = Tcl_FirstHashEntry(&s->member_table, &search); 
	 entryPtr != NULL;
	 entryPtr = Tcl_NextHashEntry(&search)) {
      m = (member_t *) Tcl_GetHashValue(entryPtr);
      if(m->cname) {
	if(!strcmp(cname,m->cname)) { 
	  if(on) { /* cont. only if the receiver data have been initalized or 
		    * a request to display local member arrived
		    * width indicats that the member has been partially initi*/
	    if((m->theImage!=NULL)||(!strcmp(cname,s->local->cname))
	       ||m->width!=0) {
	      if(m->preview==1) /* already in the active big picture mode */
		return m;
	      m->decoder=init_stream(m->decoder,m);
	    }
	    m->preview=1;
	  }
	  else
	    m->preview=0;
	}
	else{
	  if(on)
	    if(m->preview==1)
	      m->preview=2;
	}
      }
    }
    return NULL;
  }
  
  if(!strcmp(cname,s->local->cname)) { /*display the localy sent data ?*/

    s->local->preview=on;
    if(s->send[FIRST_LEVEL]) {
      if(on) { /*preview the sent data */
      	if((s->local->decoder=create_display(s->local->decoder))==NULL) {
	  perror(" could not create display");
	  return((member_t *)error);
	}
	return s->local;
     }
      else
	return NULL;
    }
    else
      return NULL;
  }
  /* display the incoming connection data ??*/
  for (entryPtr = Tcl_FirstHashEntry(&s->member_table, &search); 
       entryPtr != NULL;
       entryPtr = Tcl_NextHashEntry(&search)) {
    m = (member_t *) Tcl_GetHashValue(entryPtr);
    if(m->cname) {
      if(!strcmp(cname,m->cname)) {
	m->preview=on;
	if(on>0) {
	  if(s->scale_factor==1) {
	    if((m->theImage!=NULL)||m->width!=0) {/*wait until all the 
						   *necessary information
				    * are received and processed in 
				    * rtp_handle.c from
				    * which the first do_TkStuff should be 
				    * called.*/
	      m->decoder=init_stream(m->decoder,m);
 	    } 
	  }
	  else
	    m->preview=2;
	  return m;
	}
	else
	  return NULL;
      }
    }
    else {
      fprintf(stderr," Failed on member->ssrc=%liu ",m->ssrc);
      if(m==NULL)
	perror(" and member \n");
    } 
  }
  return((member_t *)error);
}

/***********************************************************************/
/* init_stream creates a new window for astream and initializes the
 * the decompression algorithm
 */
/***********************************************************************/
char *init_stream(char *decoder,member_t *m)
{
  int result=0;

  /* reserve a video slot for the data */
  if((result=do_TkStuff((int *)&(m->theImage),(int *)&(m->theDisp),
		(int *)&(m->theGC),(int *)&(m->mainW),
		(int *)&(m->theVisual), 
		m->width,m->height,
		(int *)&(m->shminfo),m->cname,
		m->xil_stuff))<0) {
    perror("do_TkStuff"); 
    Exit();
  }
  if(result==0)
    s->receive->preview=0; /*There were no slots anymore so do not
			    * display this stream */ 
  else {
    
    if(!decoder) {
      /* initialize the decoder structure*/
      decoder=m->init_decompression(m->width,m->height,
				    s->codec.quality,
				    (char *)m->theDisp, 
				    (int )m->mainW, 
				    (char *)m->theVisual );
    }
    m->alloc_colors((char *)decoder,(char *)m->theVisual,
		    (char *)m->theDisp,s->scale_factor);
    
    /* reinitialize the decoder structure -for JPEG this results in large 
     * DCT threshold that force the display of the first frame */
    if(decoder!=NULL)     
      m->redecode(decoder,(char *)m->theDisp,(int )m->mainW);
    return (decoder);
  }
}


/***********************************************************************/
char* create_display(char *decoder)
{
  if(s->scale_factor<=1) {
    return(init_stream(decoder,s->local));  
  }
  else{
    s->local->preview=2;
    return NULL;
  }
}

/***********************************************************************/
/*
 * close local display 
 */
void destroy_display()
{

  if(s->local->theImage){
    XFlush((Display *)s->local->theDisp);
    XSync((Display *)s->local->theDisp,TRUE);
    end_TkStuff(s->local->cname);
    s->local->theImage=NULL;
  }  
  s->local->preview=0;
}
