#ifndef _lpc_h
#define _lpc_h

#define LPC_FILTORDER		10

/* analysis parameters for one block */
typedef struct lpc_t {
  unsigned short period;
  unsigned char gain;
  char k[LPC_FILTORDER];   /* must be signed */
} lpc_t;

#define MAXWINDOW       1000    /* Max analysis window length */

struct lpc_state {
  /* general */
  int framelen;         /* number of input/output samples */
  int buflen;           /* intermediate buffer */
  /* encoder buffer */
  float s[MAXWINDOW];
  float y[MAXWINDOW];
  float h[MAXWINDOW];

  /* encoder state */
  float fa[6];
  float u;
  float u1;
  float yp1;
  float yp2;

  /* decoder state */
  int pitchctr;
  float per;
  float G;
  float k[LPC_FILTORDER+1];
  float b[LPC_FILTORDER+1];
  float bp[LPC_FILTORDER+1];
  float f[LPC_FILTORDER+1];
};

extern void *lpc_init(void *state, double period);
extern int lpc_encode(void *in_buf, int in_size, audio_descr_t
  *, void *out_buf, int *out_size, void *state, int hflag);
extern int lpc_decode(void *in_buf, int in_size, audio_descr_t
  *, void *out_buf, int *out_size, void *state);
#endif
