#
# Initialize and send messages to conferencing system.
#
proc control_init {controller} {
  if [catch {control_init_[lindex $controller 0] $controller} msg] {
    puts stderr "Error in control_init: $msg"
    control_init_tcp "tcp localhost [lindex $controller 2]" 
  }
}


#
# Generic evaluation of command.
# control_tcp generates zero-length messages if the message
# is incomplete, thus we can't use it to exit on EOF.
# Catch no_interest to avoid endless loops.
#
proc control_eval {cmd} {
  global argv0

  if {[string length $cmd] > 0} {
    if {[lsearch {proc exec rename} [lindex $cmd 0]] >= 0} {
      puts stderr "[pid] $argv0: forbidden command: $cmd"
    } elseif {[lindex $cmd 1] == "no_interest"} {
      puts stderr "[pid] $cmd"
    } else {
	  if {[catch {eval $cmd} msg]} {
        if {[string match "invalid command name *" $msg] == 0} {
          control_send "[lindex $cmd 0] error [lindex $cmd 1] [list $msg]"
        }
      }
    }
  }
}
