/*
mix_init  ---  initialize mixer.

Copyright 1993 by AT&T Bell Laboratories; all rights reserved
*/

#include "types.h"
#include "pcmu_l.h"



u_int8 sum_table[256*256];      /* table of sums */

/*
* Initialize mixing table.
*/
void mix_init(void)
{
  register pcm0, pcm1;   /* input PCM values */

  /* Fill in the sum table with the sum for each possible combination
     of PCM inputs. Can't use macro since values of > 8192 are
     possible. */
      
  for (pcm0 = 0; pcm0 < 256; pcm0++) {
    for (pcm1 = 0; pcm1 < 256; pcm1++) {
      sum_table[pcm0*256 + pcm1] = 
        l14_to_pcmu(pcmu_to_l14(pcm0) + pcmu_to_l14(pcm1));
    }
  }
} /* mix_init */
