/*
p2t  --- convert intervals to a time string, expressed in seconds
         minutes and hours.
Copyright 1993 by AT&T Bell Laboratories; all rights reserved
*/

#include <stdio.h>   /* sprintf() */



/*
* 't' time;
* 'd' postdecimal digits.
*/
char *p2t(double t, int d)
{
  static char buf[20]; 
  char *s;
  int h, m;     /* hours, minutes, seconds */

  h = t / 3600;
  t -= h*3600;
  m = t / 60;
  t -= m*60;
  if (t < 0) t = 0.;
  sprintf(buf, "%02d:%02d:%02.*f", h, m, d, t);

  /*
   * Since %02f doesn't always pad with zeros, we replace all
   * blanks with zeroes.
   */
  for (s = buf; *s; s++) {
    if (*s == ' ') *s = '0';
  }
      
  return buf;
} /* p2t */
