#
# Horizontal floating-point scale widget
# w:     window name
# label: label text
# lw:    label width (if < 0, use length of label text)
# res:   resolution
# v:     variable name 
# $Id: hscale.tcl,v 1.1 1998/07/30 11:51:26 dor Exp $
proc hscale {w label lw from to res unit v {length 100}} {
  upvar #0 $v value
  frame $w

  if {$lw < 0} {
    set lw [string length $label]
  }

  set logarithmic 0
  if {$from > 0} {
    if {$to / $from > 100} {
      set logarithmic 1
    }
  }
  if {$to - $from > 500} {
    set logarithmic 1
  }

  pack \
    [label $w.l -text $label: -width $lw -anchor nw] \
    [scale $w.s -resolution $res -showvalue yes \
     -from $from -to $to -orient h -variable $v -length $length] \
    -side left

  if {$unit != ""} {
    pack [label $w.u -text $unit -anchor nw] -side right
  }

  if {[info exists value] == 0 || $value == ""} {
    set value $from
  }
  $w.s set $value
  return $w
}
