#
# set defaults
#
# $Id: nevot_defs.tcl,v 1.3 1998/07/30 11:48:11 dor Exp $
#
proc nevot_defs {} {
  global argv0 argv env
  global agc audio_priority audio_tick controller rx sd sound tx vu
  global errorFatal

  set agc(enable)          0
  set agc(tc)              10
  set agc(low)             -40
  set agc(high)            -10

  # in announcement intervals
  set rx(hard_timeout)     50
  set rx(soft_timeout)     5

  # silence detector
  set sd(enable)           1
  set sd(echo)             3
  set sd(hysteresis)       3
  set sd(increase)         0.06
  set sd(maximum)          -20
  set sd(minimum)          -45

  # transmission
  set tx(after)            6
  set tx(before)           1
  set tx(monitor)          0
  set tx(release_audio)    5

  # VU meter
  set vu(enable)           1
  set vu(hyst)             2
  set vu(interval)         5

  # Use multicast by default; will switch to TCP/pmm automatically.
  set controller           {udp 225.2.0.1 5010}
  set audio_priority       idle 
  set audio_tick           0.02
  set role                 end_node

  # check version
  set version 3.35
  if {[infon version] != $version} {
    set errorFatal 1
    error "Version mismatch: binary [infon version], need $version"
  }

  # parse command line options
  set once 0
  while {[set err [getopt $argv "p:" opt optarg]]} {
    if {$err < 0} then {
      error "$argv0: $opt not defined\n[usage]"
    } else {
      switch -exact $opt {
        p {
          set controller [split $optarg /]
        }
      }
    }
  }
}
