#include "audio_generic.h"

/*
* Return pointer to static area with printable representation
* of audio encoding. 
*/
char *audio_ntoa(audio_descr_t *ad)
{
  static char buf[80];
  char *d = buf;
  static struct {
    audio_encoding_t encoding;
    char *name;
  } map[] = {
    {AE_PCMU, "PCMU"},
    {AE_PCMA, "PCMA"},
    {AE_DVI4, "DVI4"},
    {AE_GSM,  "GSM"},
    {AE_LPC,  "LPC"},
    {AE_L8,   "L8"},
    {AE_L16,  "L16"},
    {0,0}
  };
  int i;

  for (i = 0; map[i].name; i++) {
    if (map[i].encoding == ad->encoding) {
      strcpy(buf, map[i].name);
      d += strlen(d);
      break;
    }
  } 
  sprintf(d, " %d %d", ad->channels, ad->sample_rate);
  return buf;
} /* audio_ntoa */
